!This is supplementary material for the paper titled ``Statistical Process Control Using Dynamic Sampling Scheme''
!This programe can give the empirical distribution

program main
use imsl
implicit none

integer,parameter::w=0,simutime=100000,nq=1000
real,parameter::tarl=500.,r=0.2,deltam=0.5
integer i,j,l,n,n1(7),rx
real x,c,shift,sortedc(simutime),quantile(nq),p,k,k1(6),delta,h1
real,external::cpsec

n1=(/1,10,20,50,100,200,500/)
k1=(/0.25,0.5,0.75,1.,1.25,1.5/)

open(10,file="data.txt",status="old",position="append")

do l=7,7
n=n1(l)

write (*,"('n='i3,x,'cpsec start='f8.2)")n,cpsec()
write (10,"('n='i3,x,'cpsec start='f8.2)")n,cpsec()

!n=50
!k=k1(l)
!k=0.25
	shift=0.
	
        !k=shift/2.
	!write(10,*)"____________" 
	
        do j=1,simutime
 
		 delta=0
		 c=0
		   do i=1,n
			!generate normal n(0,1)
			call rnnor(1,x)

   				!if(i>w)then
				!x=x+shift
				!end if

	        !c=max(0.0,c+x-k)

             delta=max(deltam,(1.0-r)*delta+r*x)
			 k=delta/2.
             h1=log(1.0+2*tarl*k**2+2.332*k)/(2*k)-1.166 
             c=max(0.0,c+(x-k)/h1)   
		
		   end do

		  sortedc(j)=c
   
	end do

	   call quick_sort(sortedc,simutime)

	do i=1,nq
	   p=real(i)/nq
	   quantile(i)=sortedc(anint(p*simutime))
	!write(*,"('k='f5.2,x,'n='i3,x,'c('f6.3')='f10.4)")k,n,p,quantile(i)
	!write(10,"('k='f5.2,x,'n='i3,x,'c('f6.3')='f10.4)")k,n,p,quantile(i)
	!write(*,"('tarl='f4.0,x,'r='f4.2,x,'deltamin='f4.2,x,'n='i3,x,'c('f6.3')='f10.4)")tarl,r,deltam,n,p,quantile(i)	
	!write(10,"('tarl='f4.0,x,'r='f4.2,x,'deltamin='f4.2,x,'n='i3,x,'c('f6.3')='f10.4)")tarl,r,deltam,n,p,quantile(i)
	enddo

write (*,"('n='i3,x,'cpsec end='f8.2)")n,cpsec()
write (10,"('n='i3,x,'cpsec end='f8.2)")n,cpsec()

enddo

stop
end

subroutine quick_sort(a,n)
implicit none
integer i,j,n 
real:: a(n),t	

do i=n-1,1,-1
 do j=1,i
  if(a(j)<a(j+1))then
  t=a(j)
  a(j)=a(j+1)
  a(j+1)=t
  end if
 end do
end do
return
end subroutine
