!This is supplementary material for the paper titled ``Statistical Process Control Using Dynamic Sampling Scheme''
!This programe can give signal for the real data example

program ex1
use imsl
implicit none

integer,parameter::m=75,w=50
!real,parameter:: k=0.25,h=0.05,g=0.50,d1=0.1,d2=1.9
real,parameter::tarl=400,h=0.025,a=0.,b=3.37109,r=0.2,deltam=0.5
integer i
real x,z(m),c,xbar,std,p1,p2,p,ts,sortedc(100000),k,interval,h1,delta

open(10,file="data.txt",status="old",position="append")
open(8,file="triglyceride.txt",status="old",access="direct",form="formatted",recl=12)


write(*,"('w='i3,x,'m='i3,x,'h='f7.5,x,'a='f6.4,x,'b='f6.4,x,'r='f4.2,x,'deltamin='f4.2)")w,m,h,a,b,r,deltam
write(10,"('w='i3,x,'m='i3,x,'h='f7.5,x,'a='f6.4,x,'b='f6.4,x,'r='f4.2,x,'deltamin='f4.2)")w,m,h,a,b,r,deltam

do i=1,m
 read(8,fmt="(f10.7,x)",rec=i)z(i)
enddo

xbar=sum(z)/m
std=sqrt((sum(z**2)-m*xbar**2)/(m-1))
write(*,"('xbar='f10.1,x,'std='f10.5)")xbar,std
write(10,"('xbar='f10.1,x,'std='f10.5)")xbar,std
z=(z-xbar)/std

           delta=0
		   c=0
		   p=0
		   ts=0
		   call find_sortedcadaptive(m,z,w,tarl,r,deltam,sortedc)
		   
		   do i=m+1,149
		    
			!if(p>g)then
            !ts=ts+d2
			!else
			!ts=ts+d1
			!endif

            interval=a+b*p*p
			ts=ts+interval
			 
			 read(8,fmt="(f10.7,x)",rec=i)x
             x=(x-xbar)/std
           
		     delta=max(deltam,(1.0-r)*delta+r*x)
			 k=delta/2.
             h1=log(1.0+2*tarl*k**2+2.332*k)/(2*k)-1.166 
             c=max(0.0,c+(x-k)/h1) 

             call find_pvalue(sortedc,c,p1,p2) 
			 p=(p1+p2)/2

			 if(p>h)then
			 write(*,"('i='i3,x,'x='f10.7,x,'k='f5.3,x,'c='f10.4,x,'P-value='f5.3,x,'ts='f9.7,x,'total ts='f10.5)")i,x,k,c,p,interval,ts
			 write(10,"('i='i3,x,'x='f10.7,x,'k='f5.3,x,'c='f10.4,x,'P-value='f5.3,x,'ts='f9.7,x,'total ts='f10.5)")i,x,k,c,p,interval,ts
			 else
			 write(*,"('i='i3,x,'x='f10.7,x,'k='f5.3,x,'c='f10.4,x,'P-value='f5.3,x,'ts='f9.7,x,'total ts='f10.5,x,'Signal')")i,x,k,c,p,interval,ts
			 write(10,"('i='i3,x,'x='f10.7,x,'k='f5.3,x,'c='f10.4,x,'P-value='f5.3,x,'ts='f9.7,x,'total ts='f10.5,x,'Signal')")i,x,k,c,p,interval,ts
			 endif
			 
		   end do

stop
end


subroutine find_sortedcadaptive(m,z,n,tarl,r,deltam,sortedc)
use imsl
implicit none

integer,parameter::simutime=100000
integer i,j,n,m,b
real x,c,sortedc(simutime),k,z(m),modify,tarl,r,deltam,delta,h1

	do j=1,simutime
 
		 delta=0
		 c=0
    	  do i=1,n
		     !call rnnor(1,modify)
			 !modify=modify/10
			 call rnund(1,m,b)
			 !x=z(b)+modify
             x=z(b)
			 delta=max(deltam,(1.0-r)*delta+r*x)
			 k=delta/2.
             h1=log(1.0+2*tarl*k**2+2.332*k)/(2*k)-1.166 
             c=max(0.0,c+(x-k)/h1) 
		   end do
		  sortedc(j)=c
   
	end do

	   call quick_sort(sortedc,simutime)
	
return
end subroutine

subroutine find_pvalue(sortedc,cn,pvalue1,pvalue2)
use imsl
implicit none

integer,parameter::simutime=100000,nq=1000
integer i
real sortedc(simutime),quantile(0:nq),cn,p,pvalue1,pvalue2

	quantile=100000   
	do i=1,nq
	   p=real(i)/nq
	   quantile(i)=sortedc(anint(p*simutime))
	
		   if(quantile(i-1)>cn .and. cn>=quantile(i))then
			pvalue1=(i-1.)/nq
			pvalue2=real(i)/nq
		   endif
		  	
	enddo

return
end subroutine

subroutine quick_sort(a,n)
implicit none
integer i,j,n 
real:: a(n),t	

do i=n-1,1,-1
 do j=1,i
  if(a(j)<a(j+1))then
  t=a(j)
  a(j)=a(j+1)
  a(j+1)=t
  end if
 end do
end do
return
end subroutine



